<html>
	<head>
		<meta charset="utf-8"/>
    <meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="0" />
    <script src="https://cdn.jsdelivr.net/npm/lodash@4.17.21/lodash.min.js"></script>
    <script src="https://unpkg.com/gridjs/dist/gridjs.umd.js"></script>
    <link href="https://unpkg.com/gridjs/dist/theme/mermaid.min.css" rel="stylesheet" />
    <style>
      body {
        font-family: "Source Sans Pro", "Helvetica Neue", Arial, sans-serif

      }
    </style>
	</head>
	<body>
    <div>
      <projects></projects>
    </div>

		<script> 
      let db
      fetch("all_projects_groups.json")
        .then((response) => response.json())
        .then((data) => {
          
          let db_extract = _.map(
              _.filter(data, p => JSON.stringify(p.languages) != "{}"), // _.filter(data, p => p.languages.JavaScript != undefined),
              item => {
                return {
                  id: item.id,
                  name: item.name,
                  visibility: item.visibility,
                  path_with_namespace: item.path_with_namespace,
                  languages: JSON.stringify(item.languages),
                  members: item.members,
                  user: item.members[0] == undefined ? "" : item.members[0].username,
                  vulnerabilities: item.vulnerabilities,
                  vulnerable: item.vulnerabilities.length > 0 ? `🔴 [${item.vulnerabilities.length}]` : "🟢"

                  
                }
              }
            )
            window.data = data
            console.log(data)
            /*
            data.filter(item => item.mergeRequests.length > 0 && item.jobs.length > 0 && item.name_with_namespace.includes("cse-dt"))

            /*
            mergeRequests:
              [
                source_branch
                state
                merge_commit_sha => https://docs.gitlab.com/ee/api/jobs.html#list-project-jobs
                                => GET /projects/:id/jobs => merge_commit_sha == commit.id
              ]

              how to retrieve the job

            */
            //console.log(db_extract)

            /*
              _.find(item.members, m => m.access_level == 40)
              _.map(_.find(item.members, m => m.access_level == 40), member => {
                    return {
                      username: member.username
                    }
                  })

            [
              {
                id: 841428,
                username: 'k33g',
                name: 'Philippe Charrière',
                state: 'active',
                avatar_url: 'https://gitlab.com/uploads/-/system/user/avatar/841428/avatar.png',
                web_url: 'https://gitlab.com/k33g',
                access_level: 40,
                created_at: '2020-09-14T10:07:25.301Z',
                expires_at: null,
                membership_state: 'active'
              }
]
            */

          const javaGrid = new gridjs.Grid({
            columns: [
              {
                id: 'id',
                name: 'Id'
              }, 
              {
                id: 'name',
                name: 'Name'
              }, 
              {
                id: 'visibility',
                name: 'Visibility'
              }, 
              {
                id: 'user',
                name: 'User'
              }, 
              {
                id: 'vulnerable',
                name: 'Vulnerabilities'
              }, 
              {
                id: 'path_with_namespace',
                name: 'Path'
              },
              {
                id: 'languages', 
                name: 'Languages'
              }
            ],
            search: true,
            pagination: {
              limit: 15
            },
            data: db_extract,
            style: {
              table: {
                border: '3px solid #ccc'
              },
              th: {
                'background-color': 'rgba(0, 0, 0, 0.1)',
                color: '#000',
                'border-bottom': '3px solid #ccc',
                'text-align': 'center',
                'font-family': '"Source Sans Pro", "Helvetica Neue", Arial, sans-serif',
                'font-weight': '800'
              },
              td: {
                'font-family': '"Source Sans Pro", "Helvetica Neue", Arial, sans-serif',
                'font-weight': '400'

              }
            }
          });

          javaGrid.render(document.querySelector("projects"));

        });

		</script>
	</body>
</html>
